#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[]) {
int *array = NULL;
int i;

array = (int *) malloc(4 * sizeof(int));

if(array == NULL){
  printf("Not enough memory");
  exit(0);
}


for(i = 0; i < 4; i++) {
   printf("Type %d value : ", i+1);
   scanf("%d", &array[i]);
}

printf("\n\nThe array values==\n");

for(i = 0; i < 4; i++) {
   printf("Value at %d position : %d\n", i , array[i]);
}

free(array);

printf("\n\n");

array = (int *) calloc(4, sizeof(int));

if(array == NULL){
  printf("Not enough memory");
  exit(0);
}

for(i = 0; i < 4; i++) {
   printf("Value at %d position : %d\n", i , array[i]);
}

  free(array);

  return 0;
}


int main2(int argc, char *argv[]) {
int *array = NULL;

array = (int *) malloc(4 * sizeof(int));

if(array == NULL){
  printf("Not enough memory");
  exit(0);
}

printf("Address of %p\n", array);

int i;
for(i = 0; i < 4; i++) {
   printf("Type %d value : ", i + 1);
   scanf("%d", &array[i]);
}

array = (int *) realloc(array, sizeof(int) * 6);

printf("Address of %p\n", array);

for(i = 4; i < 6; i++) {
   printf("Type %d value : ", i + 1);
   scanf("%d", &array[i]);
}

printf("\n\n");

for(i = 0; i < 6; i++) {
   printf("Value at %d position : %d\n", i , array[i]);
}

free(array);
     	
  return 0;
}


int main3(int argc, char *argv[]) {
  int *ptrInt = (int *)malloc(sizeof(int));
  char *ptrChar = (char *)malloc(sizeof(char));
  *ptrInt = 5;
  *ptrChar = 'M';
  
  printf("%d\n", *ptrInt);
  printf("%c\n", *ptrChar);
   
  free( ptrInt);
  free( ptrChar);
  return 0;
}


int main4(int argc, char *argv[]) {
int *array;

array = (int *) malloc(4 * sizeof(int));

if(array == NULL){
  printf("Not enough memory");
  exit(0);
}
else 
{
   int i;
   for(i = 0; i < 4; i++) {
   	  printf("Type %d value : ", i + 1);
      scanf("%d", &array[i]);
   }
  
   int sum  = 0;
   for(i = 0; i < 4; i++) {
      sum = sum + array[i];
   }
   
   printf("Sum = %d\n", sum);
  
   free(array);
}
	return 0;
}


int main5(int argc, char *argv[]) {
  int **pin2D;
  int i,j,  rows, cols;
  
   printf("Type rows : ");
   scanf("%d", &rows);
   printf("Type cols : ");
   scanf("%d", &cols);
  
   pin2D = (int **) malloc(rows * sizeof(int *)); 
   
   if(pin2D == NULL) { printf("Not enough memory."); exit(0); }
   
   for (i=0; i < rows; i++) {
      pin2D[i] = (int *) malloc(cols * sizeof(int)); 
      
      if(pin2D[i] == NULL) { printf("Not enough memory."); exit(0); }
   }
  
   for (i=0; i<rows; i++) {
   	  for (j=0; j<cols; j++) {
   	  	  printf("Type value pin[%d][%d]", i, j);
   	  	  scanf("%d", &pin2D[i][j]);
	  }
   }

   int sum = 0;
   for (i=0; i<rows; i++)  {
   	  for (j=0; j<cols; j++) {
   	  	  sum += pin2D[i][j];
	  }
   }
   
   printf("\nSum = %d\n", sum);
   
   for (i=0; i<rows; i++) 
   {
      free(pin2D[i]);
   }
   
   free(pin2D);

   return 0;
}


int main6(int argc, char *argv[]) {
  int ***pin3D;
  int i,j,k,  rows, cols, height;
  
   printf("Type rows : ");
   scanf("%d", &rows);
   printf("Type cols : ");
   scanf("%d", &cols);
   printf("Type height : ");
   scanf("%d", &height);
  
   pin3D = (int ***) malloc(rows * sizeof(int **)); 
   
   if(pin3D == NULL) { printf("Not enough memory."); exit(0); }
   
   for (i=0; i < rows; i++) {
        pin3D[i] = (int **)malloc(cols * sizeof(int *)); 
 
        if(pin3D[i] == NULL) { printf("Not enough memory."); exit(0); } 
         
        for (j =0; j < cols; j++) {
        	pin3D[i][j] = (int *) malloc(height * sizeof(int)); 

        	if(pin3D[i][j] == NULL) { printf("Not enough memory."); exit(0); }
        }
    }
  
   for (i=0; i < rows; i++) {
   	  for (j=0; j < cols; j++){
     	  for (k=0; k < height; k++){
   	   	  	  printf("Type value pin[%d][%d][%d]", i, j, k);
   	  	      scanf("%d", &pin3D[i][j][k]);
	      }
      }
   }

   int sum = 0;
   for (i=0; i<rows; i++)  {
   	  for (j=0; j<cols; j++) {
   	  	for (k=0; k< height; k++) {
   	  	  sum += pin3D[i][j][k];
   	    }
	  }
   }
   printf("\nSum = %d\n", sum);

   for (i=0; i < rows; i++) {
        for (j =0; j < cols; j++) {
        	free( pin3D[i][j] ) ;
        }
        free(pin3D[i]);
    }

    free(pin3D);
  return 0;
}


